import json2md from 'json2md';

// src/lib/markdown.ts
function markdown_default(doc) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const markdown = [
    { h1: ((_b = (_a = doc.querySelector("div.bookTitle")) == null ? void 0 : _a.textContent) == null ? void 0 : _b.trim()) || "" },
    { p: ((_d = (_c = doc.querySelector("div.authors")) == null ? void 0 : _c.textContent) == null ? void 0 : _d.trim()) || "" }
  ];
  const bodyContainerNode = doc.querySelector("div.bodyContainer");
  if (bodyContainerNode == null ? void 0 : bodyContainerNode.children.length) {
    let currentSection = {};
    for (const node of bodyContainerNode.children) {
      const className = node.className;
      switch (className) {
        case "sectionHeading":
          currentSection = {
            h2: (_e = node == null ? void 0 : node.textContent) == null ? void 0 : _e.trim()
          };
          break;
        case "noteHeading":
          if (!((_g = (_f = node == null ? void 0 : node.textContent) == null ? void 0 : _f.trim()) == null ? void 0 : _g.startsWith("Bookmark"))) {
            markdown.push(currentSection);
            markdown.push({
              p: (_i = (_h = node == null ? void 0 : node.nextElementSibling) == null ? void 0 : _h.textContent) == null ? void 0 : _i.trim()
            });
            markdown.push({
              p: (_j = node == null ? void 0 : node.textContent) == null ? void 0 : _j.trim()
            });
          }
          break;
      }
    }
  }
  return json2md(markdown);
}

export { markdown_default };
