'use strict';

var fsExtra = require('fs-extra');
var jsdom = require('jsdom');
var json2md = require('json2md');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var json2md__default = /*#__PURE__*/_interopDefault(json2md);

// src/index.ts

// src/lib/json.ts
function json_default(doc) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k;
  const json = {
    title: ((_b = (_a = doc.querySelector("div.bookTitle")) == null ? void 0 : _a.textContent) == null ? void 0 : _b.trim()) || "",
    author: ((_d = (_c = doc.querySelector("div.authors")) == null ? void 0 : _c.textContent) == null ? void 0 : _d.trim()) || "",
    sections: []
  };
  const bodyContainerNode = doc.querySelector("div.bodyContainer");
  if (bodyContainerNode == null ? void 0 : bodyContainerNode.children.length) {
    let currentSectionIndex = -1;
    for (const node of bodyContainerNode.children) {
      const className = node.className;
      switch (className) {
        case "sectionHeading":
          currentSectionIndex += 1;
          json.sections[currentSectionIndex] = {
            title: ((_e = node == null ? void 0 : node.textContent) == null ? void 0 : _e.trim()) || "",
            headings: []
          };
          break;
        case "noteHeading":
          if (!((_g = (_f = node == null ? void 0 : node.textContent) == null ? void 0 : _f.trim()) == null ? void 0 : _g.startsWith("Bookmark"))) {
            (_k = json.sections.at(currentSectionIndex)) == null ? void 0 : _k.headings.push({
              title: ((_h = node == null ? void 0 : node.textContent) == null ? void 0 : _h.trim()) || "",
              content: ((_j = (_i = node == null ? void 0 : node.nextElementSibling) == null ? void 0 : _i.textContent) == null ? void 0 : _j.trim()) || ""
            });
          }
          break;
      }
    }
  }
  return json;
}
function markdown_default(doc) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j;
  const markdown = [
    { h1: ((_b = (_a = doc.querySelector("div.bookTitle")) == null ? void 0 : _a.textContent) == null ? void 0 : _b.trim()) || "" },
    { p: ((_d = (_c = doc.querySelector("div.authors")) == null ? void 0 : _c.textContent) == null ? void 0 : _d.trim()) || "" }
  ];
  const bodyContainerNode = doc.querySelector("div.bodyContainer");
  if (bodyContainerNode == null ? void 0 : bodyContainerNode.children.length) {
    let currentSection = {};
    for (const node of bodyContainerNode.children) {
      const className = node.className;
      switch (className) {
        case "sectionHeading":
          currentSection = {
            h2: (_e = node == null ? void 0 : node.textContent) == null ? void 0 : _e.trim()
          };
          break;
        case "noteHeading":
          if (!((_g = (_f = node == null ? void 0 : node.textContent) == null ? void 0 : _f.trim()) == null ? void 0 : _g.startsWith("Bookmark"))) {
            markdown.push(currentSection);
            markdown.push({
              p: (_i = (_h = node == null ? void 0 : node.nextElementSibling) == null ? void 0 : _h.textContent) == null ? void 0 : _i.trim()
            });
            markdown.push({
              p: (_j = node == null ? void 0 : node.textContent) == null ? void 0 : _j.trim()
            });
          }
          break;
      }
    }
  }
  return json2md__default.default(markdown);
}

// src/index.ts
var src_default = {
  json: (file) => {
    const html = fsExtra.readFileSync(file, "utf-8");
    const dom = new jsdom.JSDOM(html);
    const doc = dom.window.document;
    return json_default(doc);
  },
  markdown: (file) => {
    const html = fsExtra.readFileSync(file, "utf-8");
    const dom = new jsdom.JSDOM(html);
    const doc = dom.window.document;
    return markdown_default(doc);
  }
};

module.exports = src_default;
