'use strict';

// src/lib/json.ts
function json_default(doc) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k;
  const json = {
    title: ((_b = (_a = doc.querySelector("div.bookTitle")) == null ? void 0 : _a.textContent) == null ? void 0 : _b.trim()) || "",
    author: ((_d = (_c = doc.querySelector("div.authors")) == null ? void 0 : _c.textContent) == null ? void 0 : _d.trim()) || "",
    sections: []
  };
  const bodyContainerNode = doc.querySelector("div.bodyContainer");
  if (bodyContainerNode == null ? void 0 : bodyContainerNode.children.length) {
    let currentSectionIndex = -1;
    for (const node of bodyContainerNode.children) {
      const className = node.className;
      switch (className) {
        case "sectionHeading":
          currentSectionIndex += 1;
          json.sections[currentSectionIndex] = {
            title: ((_e = node == null ? void 0 : node.textContent) == null ? void 0 : _e.trim()) || "",
            headings: []
          };
          break;
        case "noteHeading":
          if (!((_g = (_f = node == null ? void 0 : node.textContent) == null ? void 0 : _f.trim()) == null ? void 0 : _g.startsWith("Bookmark"))) {
            (_k = json.sections.at(currentSectionIndex)) == null ? void 0 : _k.headings.push({
              title: ((_h = node == null ? void 0 : node.textContent) == null ? void 0 : _h.trim()) || "",
              content: ((_j = (_i = node == null ? void 0 : node.nextElementSibling) == null ? void 0 : _i.textContent) == null ? void 0 : _j.trim()) || ""
            });
          }
          break;
      }
    }
  }
  return json;
}

module.exports = json_default;
